CREATE OR REPLACE AND RESOLVE JAVA SOURCE NAMED "XXHM_QRCode"
AS //
// -- SVN Revision  : $Id: java_source_APPS.XXHM_QRCode.sql 6440 2021-08-02 08:49:58Z zawada $
//
import java.awt.*;
import java.applet.*;
import java.lang.*;
import java.awt.image.BufferedImage; 
import javax.imageio.ImageIO ;
import java.io.ByteArrayOutputStream ;
import java.io.IOException ;
import java.util.HashMap;
import java.util.Map;
//
import oracle.sql.BLOB ;
import oracle.jdbc.driver.*;
//
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
//
//
import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.NotFoundException;
import com.google.zxing.WriterException;
import com.google.zxing.client.j2se.MatrixToImageWriter;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.qrcode.decoder.ErrorCorrectionLevel;
import com.google.zxing.qrcode.QRCodeWriter;
import com.google.zxing.EncodeHintType;
//
//
@SuppressWarnings("deprecation")
public class XXHM_QRCode
{
   private static Map<EncodeHintType, Object> hints = new HashMap<EncodeHintType, Object>() {
        private static final long serialVersionUID = 1L ;
        {
            put(EncodeHintType.ERROR_CORRECTION, ErrorCorrectionLevel.H); // Set the error correction level of QR QR code (H is the highest level) specific level information
            put(EncodeHintType.CHARACTER_SET, "utf-8") ; // Set the encoding method
        }
    } ;
    
    public static oracle.sql.BLOB toQRCode( String contentString ) 
    {
       //java.lang.System.out.println("Start: " + contentString ) ;
       
       OracleDriver driver       = new OracleDriver();
       Connection   conn         = null ;
       BLOB         qrCode       = null ;
      
       try { conn = driver.defaultConnection() ;
           }
           catch (SQLException e)
                 { java.lang.System.out.println("SQLException defaultConnection") ;
                 }
       
       try { qrCode = BLOB.createTemporary(conn, false, BLOB.DURATION_CALL) ;
           }
           catch (SQLException e)
                 { java.lang.System.out.println("SQLException LOB.createTemporary") ;
                 }
       
       int width  = 300 ;
       int height = 300 ;
       
       QRCodeWriter qrCodeWriter = new QRCodeWriter();
       try { BitMatrix              bitMatrix     = qrCodeWriter.encode(contentString, BarcodeFormat.QR_CODE, width, height, hints) ;
             BufferedImage          bufferedImage = MatrixToImageWriter.toBufferedImage(bitMatrix) ;
             ByteArrayOutputStream  baos          = new ByteArrayOutputStream() ;
             ImageIO.write(bufferedImage, "png", baos);
             
             long offset  = 1 ; // 1 nicht 0 !!!
             byte[] bytes = baos.toByteArray() ;
             qrCode.putBytes(offset,bytes) ; 
           }
           catch (Exception e)
                 { java.lang.System.out.println("Exception: " + e.getMessage() ) ;
                 };
        
       return qrCode ;
   }  
}


-- End of DDL Script for Java Source APPS.XXHM_QRCode

