﻿CREATE OR REPLACE 
PACKAGE apps.xxhm_qrcode
IS

   -- SVN Revision  : $Id: package_APPS.XXHM_QRCODE.sql 6440 2021-08-02 08:49:58Z zawada $

FUNCTION toQRCode
         ( p_ContentString VARCHAR2 )
           RETURN          BLOB ;


PROCEDURE testQRCode ;

END ;
/

CREATE OR REPLACE 
PACKAGE BODY apps.xxhm_qrcode
IS

   -- SVN Revision  : $Id: package_APPS.XXHM_QRCODE.sql 6440 2021-08-02 08:49:58Z zawada $

FUNCTION toQRCode
         ( p_ContentString VARCHAR2 )
           RETURN          BLOB
AS
LANGUAGE JAVA
NAME 'XXHM_QRCode.toQRCode(java.lang.String) return oracle.sql.BLOB' ;


PROCEDURE testQRCode
IS
   l_qrBlob     BLOB;

   l_file      UTL_FILE.FILE_TYPE;
   l_buffer    RAW(32767);
   l_amount    BINARY_INTEGER := 32767;
   l_pos       INTEGER := 1;
   l_blob_len  INTEGER;

BEGIN
   -- We want see Java Output
   dbms_java.set_output(10000) ;

   -- Now Call the stored program
   l_qrBlob := xxhm_qrcode.toQRCode
               ( p_contentstring=>'Ω Felix, qui potuit rerum cognoscere causas! Ω') ;

   dbms_output.put_line(dbms_lob.getlength(l_qrBlob) ) ;

   l_file := UTL_FILE.fopen('IMPORT_MIG','QRCode.png','wb', 32767);
   l_blob_len := DBMS_LOB.getlength(l_qrBlob);

   WHILE l_pos <= l_blob_len
   LOOP
     dbms_output.put_line('Loop' ) ;
     DBMS_LOB.read(l_qrBlob, l_amount, l_pos, l_buffer);
     UTL_FILE.put_raw(l_file, l_buffer, TRUE);
     l_pos := l_pos + l_amount;
   END LOOP;

   -- Close the file.
   UTL_FILE.fclose(l_file);
END testQRCode;


END ;
/


-- End of DDL Script for Package APPS.XXHM_QRCODE

